diff -Naur openssl-1.0.0q.orig/libopeay_implmodule.h openssl-1.0.0q/libopeay_implmodule.h
--- openssl-1.0.0q.orig/libopeay_implmodule.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/libopeay_implmodule.h	2017-04-25 16:23:40.899798155 +0200
@@ -0,0 +1,127 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2008 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#ifndef MODULES_LIBOPEAY_LIBOPEAY_IMPLMODULE_H
+#define MODULES_LIBOPEAY_LIBOPEAY_IMPLMODULE_H
+
+#if defined(_SSL_USE_OPENSSL_) || defined(LIBOPEAY_ENABLE_PARTLY_OPENSSL_SUPPORT)
+
+#ifdef OPENSSL_SYS_WIN32
+/* Under Win32 thes are defined in wincrypt.h */
+#undef PKCS7_ISSUER_AND_SERIAL
+#undef PKCS7_SIGNER_INFO
+#undef X509_NAME
+#undef X509_CERT_PAIR
+#endif
+
+#include <openssl/ossl_typ.h>
+#include <openssl/safestack.h>
+#include <openssl/lhash.h>
+#include <openssl/err.h>
+#include "modules/libopeay/crypto/rand/rand_lcl.h"
+
+/* MUST match corresponding defintion STATE_SIZE in crypto/rand/md_rand.c */
+#define LIBOPEAY_RAND_STATE_SIZE	1023
+
+#ifdef OPERA_SMALL_VERSION
+
+class Libopeay_ImplementModuleData
+{
+public:
+	/** @name Types of some variables below.
+	  *
+	  * This list is sorted by type name.
+	  *
+	  * Name format should be the same as for variables below.
+	  *
+	  * @{
+	  */
+	typedef unsigned char hmac__m_t[EVP_MAX_MD_SIZE];
+	typedef long          md_rand__md_count_t[2];
+	typedef unsigned char md_rand__md_t[MD_DIGEST_LENGTH];
+	typedef unsigned char md_rand__state_t[LIBOPEAY_RAND_STATE_SIZE+MD_DIGEST_LENGTH];
+	/** @} */
+
+	/** @name List of OpenSSL global and static variables.
+	  *
+	  * This list is sorted by variable name.
+	  *
+	  * Name format should be: FILENAME__VARNAME, where:
+	  *     FILENAME - filename wher the variable is originally defined, without extension.
+	  *                Example: obj_dat for obj_dat.c file.
+	  *     VARNAME  - variable name as it is originally defined.
+	  *                Example: new_nid.
+	  * Example of the result: obj_dat__new_nid.
+	  *
+	  * NB: old variables do not follow this naming rule.
+	  * Nevertheless, new variables should follow the rule.
+	  *
+	  * @{
+	  */
+#ifndef OPENSSL_NO_ENGINE
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(STACK_OF(ENGINE_CLEANUP_ITEM) *, cleanup_stack);
+#endif // OPENSSL_NO_ENGINE
+#if defined SSL_USE_WEAK_CIPHERS
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(int,                     DES_check_key);
+#endif
+#ifndef OPENSSL_NO_ENGINE
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(ENGINE *,                engine_list_head);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(ENGINE *,                engine_list_tail);
+#endif // OPENSSL_NO_ENGINE
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(ERR_STATE,               err__fallback);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(const ERR_FNS *,         err__err_fns);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(LHASH_OF(ERR_STRING_DATA) *, err__int_error_hash);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(LHASH_OF(ERR_STATE) *,   err__int_thread_hash);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(int,                     err__int_thread_hash_references);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(int,                     err__int_err_library_number);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(_LHASH *,                ex_data);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(int,                     free_type);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(int,                     have_perfc);
+#if defined(_MSC_VER) && defined(_M_X86)
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(int,                     have_tsc);
+#endif
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(hmac__m_t,               hmac__m);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(_LHASH *,                int_thread_hash);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(int,                     int_thread_hash_references);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(unsigned int,            md_rand__crypto_lock_rand);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(double,                  md_rand__entropy);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(int,                     md_rand__initialized);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(CRYPTO_THREADID,         md_rand__locking_threadid);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(md_rand__md_t,           md_rand__md);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(md_rand__md_count_t,     md_rand__md_count);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(md_rand__state_t,        md_rand__state);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(int,                     md_rand__state_index);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(int,                     md_rand__state_num);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(STACK_OF(NAME_FUNCS) *,  name_funcs_stack);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(_LHASH *,                names_lh);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(LHASH_OF(ADDED_OBJ) *,   obj_dat__added);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(int,                     obj_dat__new_nid);
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(_STACK *,                pbe_algs);
+#endif // LIBOPEAY_PKCS12_SUPPORT
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(volatile int,            stirred_pool);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(STACK_OF(X509_TRUST) *,  trtable);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(const X509_CRL_METHOD *, x_crl__default_crl_method);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA(STACK_OF(X509_PURPOSE)*, xptable);
+	/** @} */
+
+#ifdef LIBOPEAY_X509_EX_DATA
+	int ev_oid_x509_list_index; // Actually used by libssl, but fits better here
+#	define g_ev_oid_x509_list_index			g_opera->libopeay_module.m_data->ev_oid_x509_list_index
+#endif
+
+public:
+	Libopeay_ImplementModuleData();
+	~Libopeay_ImplementModuleData(); 	// Variables are destroyed by internal cleanup calls
+};
+
+#endif /* OPERA_SMALL_VERSION */
+
+#endif /* _SSL_USE_OPENSSL_ */
+
+#endif /* !MODULES_LIBOPEAY_LIBOPEAY_MODULE_H */
diff -Naur openssl-1.0.0q.orig/libopeay_module.cpp openssl-1.0.0q/libopeay_module.cpp
--- openssl-1.0.0q.orig/libopeay_module.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/libopeay_module.cpp	2017-04-25 16:23:40.900798283 +0200
@@ -0,0 +1,281 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+ *
+ * Copyright (C) 1995-2011 Opera Software AS.  All rights reserved.
+ *
+ * This file is part of the Opera web browser.
+ * It may not be distributed under any circumstances.
+ */
+#include "modules/libopeay/libopeay_module.h"
+
+#if defined(_SSL_USE_OPENSSL_) || defined(LIBOPEAY_ENABLE_PARTLY_OPENSSL_SUPPORT)
+#include "modules/libopeay/openssl/cryptlib.h"
+#include "modules/libopeay/openssl/err.h"
+#include "modules/libopeay/openssl/rand.h"
+#include "modules/libopeay/openssl/x509v3.h"
+#include "modules/libopeay/openssl/pkcs12.h"
+
+#include "modules/libopeay/libopeay_implmodule.h"
+#include "modules/libopeay/libopeay_arrays.h"
+
+#include "modules/prefs/prefsmanager/collections/pc_network.h"
+#include "modules/libssl/method_disable.h"
+
+#ifndef OPENSSL_NO_ENGINE
+# include "modules/libopeay/openssl/engine.h"
+#endif
+
+#ifdef OPERA_SMALL_VERSION
+
+extern "C"{
+
+#ifdef HAS_COMPLEX_GLOBALS
+extern X509_CRL_METHOD const OPENSSL_GLOBAL_ITEM_NAME(x_crl__int_crl_meth);
+#endif
+
+// This list is sorted by variable name.
+#ifndef OPENSSL_NO_ENGINE
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(STACK_OF(ENGINE_CLEANUP_ITEM) *, cleanup_stack);
+#endif
+#if defined SSL_USE_WEAK_CIPHERS
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(int,                     DES_check_key);
+#endif
+#ifndef OPENSSL_NO_ENGINE
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(ENGINE *,                engine_list_head);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(ENGINE *,                engine_list_tail);
+#endif
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(ERR_STATE,               err__fallback);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(const ERR_FNS *,         err__err_fns);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(LHASH_OF(ERR_STRING_DATA) *, err__int_error_hash);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(LHASH_OF(ERR_STATE) *,   err__int_thread_hash);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(int,                     err__int_thread_hash_references);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(int,                     err__int_err_library_number);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(_LHASH *,                ex_data);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(int,                     free_type);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(int,                     have_perfc);
+#if defined(_MSC_VER) && defined(_M_X86)
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(int,                     have_tsc);
+#endif
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(Libopeay_ImplementModuleData::hmac__m_t, hmac__m);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(_LHASH *,                int_thread_hash);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(int,                     int_thread_hash_references);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(unsigned int,            md_rand__crypto_lock_rand);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(double,                  md_rand__entropy);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(int,                     md_rand__initialized);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(CRYPTO_THREADID,         md_rand__locking_threadid);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(Libopeay_ImplementModuleData::md_rand__md_t,       md_rand__md);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(Libopeay_ImplementModuleData::md_rand__md_count_t, md_rand__md_count);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(Libopeay_ImplementModuleData::md_rand__state_t,    md_rand__state);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(int,                     md_rand__state_index);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(int,                     md_rand__state_num);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(STACK_OF(NAME_FUNCS) *,  name_funcs_stack);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(_LHASH *,                names_lh);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(LHASH_OF(ADDED_OBJ) *,   obj_dat__added);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(int,                     obj_dat__new_nid);
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(_STACK *,                pbe_algs);
+#endif
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(volatile int,            stirred_pool);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(STACK_OF(X509_TRUST) *,  trtable);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(const X509_CRL_METHOD *, x_crl__default_crl_method);
+OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(STACK_OF(X509_PURPOSE) *, xptable);
+
+// Implementation resides in modules/libopeay/addon/purposes.h.
+int AddOperaSpecificPurposes();
+
+} // extern "C"
+
+Libopeay_ImplementModuleData::Libopeay_ImplementModuleData()
+{
+	// This list is sorted by variable name.
+#ifndef OPENSSL_NO_ENGINE
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(cleanup_stack)              = NULL;
+#endif
+#if defined SSL_USE_WEAK_CIPHERS
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(DES_check_key)              = 0;
+#endif
+#ifndef OPENSSL_NO_ENGINE
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(engine_list_head) = NULL;
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(engine_list_tail) = NULL;
+#endif
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(err__err_fns                = NULL);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(err__int_error_hash         = NULL);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(err__int_thread_hash        = NULL);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(err__int_thread_hash_references = 0);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(err__int_err_library_number = ERR_LIB_USER);
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(ex_data)                    = NULL;
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(free_type)                  = 0;
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(have_perfc)                 = 1;
+#if defined(_MSC_VER) && defined(_M_X86)
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(have_tsc)                   = 1;
+#endif
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(int_thread_hash)            = NULL;
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(int_thread_hash_references) = 0;
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(md_rand__crypto_lock_rand)  = 0;
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(md_rand__entropy)           = 0;
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(md_rand__initialized)       = 0;
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(md_rand__state_index)       = 0;
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(md_rand__state_num)         = 0;
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(name_funcs_stack)           = NULL;
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(names_lh)                   = NULL;
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(obj_dat__added)             = NULL;
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(obj_dat__new_nid)           = 0;
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(pbe_algs)                   = NULL;
+#endif
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(stirred_pool)               = 0;
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(trtable)                    = NULL;
+#if defined(_SSL_USE_OPENSSL_) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(x_crl__default_crl_method)  = &OPENSSL_GLOBAL_ITEM_NAME(x_crl__int_crl_meth);
+#endif
+	OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(xptable)                    = NULL;
+
+#ifdef LIBOPEAY_X509_EX_DATA
+	ev_oid_x509_list_index = -1;
+#endif
+
+# define MEMSET0(a) op_memset(&OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(a), 0, sizeof(OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(a)));
+
+	// Init arrays and structures by binary nulls.
+	MEMSET0(err__fallback);
+	MEMSET0(hmac__m);
+	MEMSET0(md_rand__locking_threadid);
+	MEMSET0(md_rand__md);
+	MEMSET0(md_rand__md_count);
+	MEMSET0(md_rand__state);
+
+# undef MEMSET0
+}
+
+// Copied from err.c
+#define err_clear_data(p,i) \
+	do { \
+	if (((p)->err_data[i] != NULL) && \
+		(p)->err_data_flags[i] & ERR_TXT_MALLOCED) \
+		{  \
+		OPENSSL_free((p)->err_data[i]); \
+		(p)->err_data[i]=NULL; \
+		} \
+	(p)->err_data_flags[i]=0; \
+	} while(0)
+
+#define err_clear(p,i) \
+	do { \
+	(p)->err_flags[i]=0; \
+	(p)->err_buffer[i]=0; \
+	err_clear_data(p,i); \
+	} while(0)
+
+Libopeay_ImplementModuleData::~Libopeay_ImplementModuleData()
+{
+	if (g_opera->libopeay_module.m_data)
+	{
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+		EVP_PBE_cleanup();
+#endif
+#ifndef OPENSSL_NO_ENGINE 
+		ENGINE_cleanup();
+#endif
+#if defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
+		CRYPTO_cleanup_all_ex_data();
+#endif
+
+		ERR_remove_thread_state(NULL);
+	}	
+
+	ERR_STATE *err_fallback = &OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(err__fallback);
+	for (int i=0; i<ERR_NUM_ERRORS; i++)
+	{
+		err_clear(err_fallback, i);
+	}
+	err_fallback->top=err_fallback->bottom=0;
+}
+
+LibopeayModule::LibopeayModule() : 
+#ifndef HAS_COMPLEX_GLOBALS
+	m_consts(NULL),
+#endif
+	m_data(NULL)
+#if !defined LIBOPEAY_DISABLE_MD5_PARTIAL
+	, turn_off_md5(FALSE)
+#endif
+#if !defined LIBOPEAY_DISABLE_SHA1_PARTIAL
+	, turn_off_sha1(FALSE)
+#endif
+{
+}
+
+void LibopeayModule::InitL(const OperaInitInfo& info)
+{
+#ifndef HAS_COMPLEX_GLOBALS
+#if defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
+	InitGlobalsL();
+#endif
+#endif
+
+	m_data = OP_NEW_L(Libopeay_ImplementModuleData, ());
+
+#ifndef LIBOPEAY_DISABLE_MD5_PARTIAL
+	turn_off_md5  = ((g_pcnet->GetIntegerPref(PrefsCollectionNetwork::CryptoMethodOverride) & CRYPTO_METHOD_DISABLE_MD5) != 0 ? TRUE : FALSE);
+#endif
+#ifndef LIBOPEAY_DISABLE_SHA1_PARTIAL
+	turn_off_sha1 = ((g_pcnet->GetIntegerPref(PrefsCollectionNetwork::CryptoMethodOverride) & CRYPTO_METHOD_DISABLE_SHA1) != 0 ? TRUE : FALSE);
+#endif
+
+#if defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
+
+#ifndef OPENSSL_NO_ENGINE
+	ENGINE_load_openssl();
+#endif
+
+	OpenSSL_add_all_ciphers();
+	OpenSSL_add_all_digests();
+
+	int purposes_err = AddOperaSpecificPurposes();
+	int other_err    = ERR_peek_error();
+	ERR_clear_error();
+
+	if(purposes_err != 1 || other_err != 0)
+		LEAVE(OpStatus::ERR);
+
+#endif // defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
+}
+
+void LibopeayModule::Destroy()
+{
+}
+
+LibopeayModule::~LibopeayModule()
+{
+	// if cleaning up due to startup failure, libopeay might not have been initialised
+	if (m_data)
+	{
+#if defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
+
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+		EVP_PBE_cleanup();
+#endif
+		EVP_cleanup();
+		X509_PURPOSE_cleanup();
+		//X509_TRUST_cleanup();
+#ifndef OPENSSL_NO_ENGINE
+		ENGINE_cleanup();
+#endif
+		CRYPTO_cleanup_all_ex_data();
+
+		ERR_remove_thread_state(NULL);
+#endif // _SSL_USE_OPENSSL_
+
+		OP_DELETE(m_data);
+		m_data = NULL;
+
+#endif // defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
+	}
+
+#ifndef HAS_COMPLEX_GLOBALS
+#if defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
+	DestroyGlobals();
+#endif
+#endif
+}
+
+#endif // OPERA_SMALL_VERSION
diff -Naur openssl-1.0.0q.orig/libopeay_module.h openssl-1.0.0q/libopeay_module.h
--- openssl-1.0.0q.orig/libopeay_module.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/libopeay_module.h	2017-04-25 16:23:40.900798283 +0200
@@ -0,0 +1,79 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2008 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#ifndef MODULES_LIBOPEAY_LIBOPEAY_MODULE_H
+#define MODULES_LIBOPEAY_LIBOPEAY_MODULE_H
+
+#if defined(_SSL_USE_OPENSSL_) || defined(LIBOPEAY_ENABLE_PARTLY_OPENSSL_SUPPORT)
+
+#ifndef CLEAR_PASSWD_FROM_MEMORY
+#error "For security reasons FEATURE_CLEAR_PASSWORDS *MUST* be YES when libssl with libopeay is used"
+#endif
+
+#include "modules/hardcore/opera/module.h"
+#include "modules/util/simset.h"
+
+class Libopeay_ImplementModuleData;
+class Libopeay_GlobalConst_Data;
+
+class LibopeayModule : public OperaModule
+{
+#ifndef HAS_COMPLEX_GLOBALS
+private:
+	Head global_const_list;
+
+public:
+	Libopeay_GlobalConst_Data *m_consts;
+#endif
+
+public:
+	Libopeay_ImplementModuleData *m_data;
+
+public:
+	LibopeayModule();
+	virtual void InitL(const OperaInitInfo& info);
+
+	virtual void Destroy();
+	virtual ~LibopeayModule();
+
+#ifndef HAS_COMPLEX_GLOBALS
+	class Libopeay_ConstBase : public Link
+	{
+	public:
+		Libopeay_ConstBase();
+		virtual ~Libopeay_ConstBase();
+		virtual void InitL(int phase)=0;
+		virtual void Destroy()=0;
+	};
+
+	void AddComplexConstGlobal(Libopeay_ConstBase *item);
+
+private:
+	void InitGlobalsL();
+	void InitGlobalsPhaseL(int phase);
+	void DestroyGlobals();
+
+#endif
+public:
+#if !defined LIBOPEAY_DISABLE_MD5_PARTIAL
+	BOOL turn_off_md5;
+#endif
+#if !defined LIBOPEAY_DISABLE_SHA1_PARTIAL
+	BOOL turn_off_sha1;
+#endif
+};
+
+#define LIBOPEAY_MODULE_REQUIRED
+
+#define g_libopeay_module			g_opera->libopeay_module
+#define g_turn_off_md5				g_libopeay_module.turn_off_md5
+#define g_turn_off_sha1				g_libopeay_module.turn_off_sha1
+
+#endif /* _SSL_USE_OPENSSL_ */
+
+#endif /* !MODULES_LIBOPEAY_LIBOPEAY_MODULE_H */
diff -Naur openssl-1.0.0q.orig/module.about openssl-1.0.0q/module.about
--- openssl-1.0.0q.orig/module.about	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/module.about	2017-04-25 16:23:40.901798130 +0200
@@ -0,0 +1,7 @@
+module:             libopeay
+core group:         network
+owner:              alexeik
+co-owners:          haavardm
+others:
+core qa:            sadrabinski
+description:        OpenSSL crypto library version 0.9.8k. Must ONLY be used by the libssl, externalssl or libcrypto module.
diff -Naur openssl-1.0.0q.orig/module.export openssl-1.0.0q/module.export
--- openssl-1.0.0q.orig/module.export	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/module.export	2017-04-25 16:23:40.901798130 +0200
@@ -0,0 +1,124 @@
+
+API_LIBOPEAY_OPENSSL_SUPPORT			yngve
+
+	Activates the use of OpenSSL crypto export
+
+	Defines		: OPERA_SMALL_VERSION, OPENSSL_NO_RAND_FILE
+	Depends on	: _SSL_USE_OPENSSL_, FEATURE_NATIVE_SSL
+
+API_LIBOPEAY_ELGAMAL_SUPPORT			yngve
+
+	This API activates the ElGamal public key encryption support
+
+	Defines		: NEED_LIBOPEAY_ELGAMAL
+
+API_LIBOPEAY_CFB_SUPPORT			yngve
+
+	This API activates the CFB encryption support
+
+	Defines		: NEED_LIBOPEAY_CFB_SUPPORT
+
+API_LIBOPEAY_CAST_RIPE_SUPPORT			yngve
+
+	This API activates the CAST and RIPEMD support
+
+	Defines		: NEED_LIBOPEAY_CAST_RIPE_SUPPORT
+
+API_LIBOPEAY_VERIFY_PARAM						yngve
+
+	Activates code needed by extended validation code
+
+	Defines		:  OPERA_NEED_TXT2OBJ, OPERA_NEED_POLICY_FUN, OPERA_NEED_VERIFY_PARAM
+
+API_LIBOPEAY_ASYNCHRONOUS_KEYGENERATION	haavardm		
+
+	This enables asynchronous generation of rsa key pairs 
+
+	Defines		: LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
+	Depends on	: _SSL_USE_OPENSSL_
+	
+API_LIBOPEAY_ENABLE_PARTLY_OPENSSL_SUPPORT	haavardm
+	In case libcrypto want to "rip-out" a few algorithms without using all of libopeay.
+	This ensures that some important defines are set. Only libcrypto should import this.
+
+	Defines		: LIBOPEAY_ENABLE_PARTLY_OPENSSL_SUPPORT, OPERA_SMALL_VERSION
+	Depends on	: API_CRYPTO_API
+
+API_LIBOPEAY_X509_EX_DATA		yngve
+
+	This enables the external data API in the X509 objects
+	
+	Defines		:	LIBOPEAY_X509_EX_DATA
+	Depends on	: FEATURE_SSL, FEATURE_NATIVE_SSL, FEATURE_3P_OPENSSL
+
+API_LIBOPEAY_PKCS12     yngve
+
+	This enables the PKCS #12 code in libopeay, allowing export and import of
+	certificates with their private keys.
+
+	Defines		:	LIBOPEAY_PKCS12_SUPPORT
+	Depends on	: FEATURE_SSL, FEATURE_NATIVE_SSL, FEATURE_3P_OPENSSL
+
+API_LIBOPEAY_RC4_256		yngve
+
+	This activates support for the 256 bit version of RC4
+	
+	Defines		: LIBOPEAY_USE_RC4_256
+	Depends on	: FEATURE_SSL, FEATURE_NATIVE_SSL, FEATURE_3P_OPENSSL
+
+API_USE_OPENSSL_CERTIFICATE_VERIFICATION haavardm
+	This gives the option to use certificate verification without turning on the  whole libopeay module.
+	Footprint of this option is not known (but probably quite big).  Only libcrypto can import this API. Use this
+	functionality from libcrypto instead.
+
+	Defines		: USE_OPENSSL_CERTIFICATE_VERIFICATION
+	Depends on 	: !FEATURE_NATIVE_SSL and CRYPTO_API_SUPPORT
+
+API_USE_OPENSSL_OCSP                                        alexeik
+	Enables OCSP code.
+
+	Defines		: USE_OPENSSL_OCSP
+	Depends on 	: USE_OPENSSL_CERTIFICATE_VERIFICATION
+
+API_LIBOPEAY_HASH_SHA512	haavardm
+	Rips out SHA512. Only libcrypto can import this API. Use this
+	functionality from libcrypto instead.
+
+	Defines		: LIBOPEAY_HASH_SHA512_SUPPORT
+	Depends on 	: !FEATURE_NATIVE_SSL and CRYPTO_API_SUPPORT
+
+API_LIBOPEAY_HASH_SHA256	haavardm
+	Rips out SHA256. Only libcrypto can import this API. Use this
+	functionality from libcrypto instead.
+
+	Defines		: LIBOPEAY_HASH_SHA256_SUPPORT
+	Depends on 	: !FEATURE_NATIVE_SSL and CRYPTO_API_SUPPORT
+
+API_LIBOPEAY_HASH_SHA1	haavardm
+	Rips out SHA1. Only libcrypto can import this API. Use this
+	functionality from libcrypto instead. 
+
+	Defines		: LIBOPEAY_HASH_SHA1_SUPPORT
+	Depends on 	: !FEATURE_NATIVE_SSL and CRYPTO_API_SUPPORT
+
+API_LIBOPEAY_HASH_MD5	haavardm
+	Rips out MD5. Only libcrypto can import this API. Use this
+	functionality from libcrypto instead.
+
+	Defines		: LIBOPEAY_HASH_MD5_SUPPORT
+	Depends on 	: !FEATURE_NATIVE_SSL and CRYPTO_API_SUPPORT
+
+API_LIBOPEAY_ENCRYPTION_AES	haavardm
+	Rips out AES. Only libcrypto can import this API. Use this
+	functionality from libcrypto instead .
+
+	Defines		: LIBOPEAY_ENCRYPTION_AES_SUPPORT
+	Depends on 	: !FEATURE_NATIVE_SSL and CRYPTO_API_SUPPORT
+
+API_LIBOPEAY_STREAM_ENCRYPTION_RC4	haavardm
+	Rips out RC4. Only libcrypto can import this API. Use this
+	functionality from libcrypto instead .
+
+	Defines		: LIBOPEAY_STREAM_ENCRYPTION_RC4_SUPPORT
+	Depends on 	: !FEATURE_NATIVE_SSL and CRYPTO_API_SUPPORT
+	
\ No newline at end of file
diff -Naur openssl-1.0.0q.orig/module.ignore openssl-1.0.0q/module.ignore
--- openssl-1.0.0q.orig/module.ignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/module.ignore	2017-04-25 16:23:40.901798130 +0200
@@ -0,0 +1,189 @@
+crypto/LPdir_unix.c
+crypto/LPdir_vms.c
+crypto/LPdir_win.c
+crypto/aes/aes_ige.c
+crypto/asn1/asn1_gen.c
+crypto/asn1/asn1_par.c
+crypto/asn1/asn_mime.c
+crypto/asn1/evp_asn1.c
+crypto/asn1/f_enum.c
+crypto/asn1/f_int.c
+crypto/asn1/f_string.c
+crypto/asn1/n_pkey.c
+crypto/asn1/p5_pbev2.c
+crypto/asn1/t_pkey.c
+crypto/bf/bf_ofb64.c
+crypto/bf/bf_opts.c
+crypto/bf/bfspeed.c
+crypto/bf/bftest.c
+crypto/bio/b_sock.c
+crypto/bio/bio_cb.c
+crypto/bio/bss_conn.c
+crypto/bio/bss_file.c
+crypto/bio/bss_log.c
+crypto/bio/bss_rtcp.c
+crypto/bn/bn_opt.c
+crypto/bn/divtest.c
+crypto/camellia/cmll_cfb.c
+crypto/cast/c_ofb64.c
+crypto/cast/cast_spd.c
+crypto/cast/castopts.c
+crypto/cast/casttest.c
+crypto/cms/cms_dd.c
+crypto/cms/cms_ess.c
+crypto/cms/cms_sd.c
+crypto/cms/cms_smime.c
+crypto/conf/conf_def.c
+crypto/conf/conf_mod.c
+crypto/cversion.c
+crypto/des/des.c
+crypto/des/des.h
+crypto/des/des_lib.c
+crypto/des/des_old.h
+crypto/des/des_opts.c
+crypto/des/destest.c
+crypto/des/ecb_enc.c
+crypto/des/enc_writ.c
+crypto/des/fcrypt.c
+crypto/des/read_pwd.c
+crypto/des/rpc_des.h
+crypto/des/speed.c
+crypto/dh/dhtest.c
+crypto/dsa/dsa_gen.c
+crypto/dsa/dsagen.c
+crypto/dsa/dsatest.c
+crypto/dso/dso_vms.c
+crypto/ebcdic.h
+crypto/ebcdic.h
+crypto/ec/ectest.c
+crypto/ecdh/ecdhtest.c
+crypto/ecdsa/ecdsatest.c
+crypto/engine/eng_cryptodev.c
+crypto/engine/eng_openssl.c
+crypto/engine/eng_padlock.c
+crypto/engine/enginetest.c
+crypto/err/err_prn.c
+crypto/evp/bio_b64.c
+crypto/evp/bio_enc.c
+crypto/evp/bio_ok.c
+crypto/evp/evp.h
+crypto/evp/evp_test.c
+crypto/evp/openbsd_hw.c
+crypto/evp/p5_crpt.c
+crypto/evp/p5_crpt2.c
+crypto/evp/p_seal.c
+crypto/hmac/hmac.c
+crypto/hmac/hmac.h
+crypto/hmac/hmactest.c
+crypto/idea/i_ofb64.c
+crypto/idea/idea_spd.c
+crypto/idea/ideatest.c
+crypto/jpake/jpake.c
+crypto/jpake/jpake.h
+crypto/lhash/lh_test.c
+crypto/md2/md2.c
+crypto/md2/md2.h
+crypto/md2/md2_one.c
+crypto/md2/md2test.c
+crypto/md4/md4.c
+crypto/md4/md4_one.c
+crypto/md4/md4s.cpp
+crypto/md4/md4test.c
+crypto/md5/md5.c
+crypto/md5/md5_one.c
+crypto/md5/md5s.cpp
+crypto/md5/md5test.c
+crypto/mdc2/mdc2.h
+crypto/mdc2/mdc2_one.c
+crypto/mdc2/mdc2dgst.c
+crypto/mdc2/mdc2test.c
+crypto/mem_dbg.c
+crypto/ocsp/ocsp_ht.c
+crypto/ocsp/ocsp_srv.c
+crypto/pem/pem.h
+crypto/pem/pem_info.c
+crypto/pem/pem_lib.c
+crypto/pem/pem_pk8.c
+crypto/pem/pem_pkey.c
+crypto/pem/pem_seal.c
+crypto/pkcs12/p12_decr.c
+crypto/pkcs12/p12_npas.c
+crypto/pkcs7/bio_ber.c
+crypto/pkcs7/dec.c
+crypto/pkcs7/enc.c
+crypto/pkcs7/pk7_doit.c
+crypto/pkcs7/pk7_mime.c
+crypto/pkcs7/pk7_smime.c
+crypto/pkcs7/sign.c
+crypto/pkcs7/verify.c
+crypto/rand/rand_os2.c
+crypto/rand/rand_vms.c
+crypto/rand/randfile.c
+crypto/rand/randtest.c
+crypto/rc2/rc2ofb64.c
+crypto/rc2/rc2speed.c
+crypto/rc2/rc2test.c
+crypto/rc4/rc4.c
+crypto/rc4/rc4s.cpp
+crypto/rc4/rc4speed.c
+crypto/rc4/rc4test.c
+crypto/rc5/rc5ofb64.c
+crypto/rc5/rc5speed.c
+crypto/ripemd/asm/rips.cpp
+crypto/ripemd/rmd160.c
+crypto/ripemd/rmd_one.c
+crypto/ripemd/rmdtest.c
+crypto/rsa/rsa_oaep.c
+crypto/rsa/rsa_pss.c
+crypto/rsa/rsa_test.c
+crypto/seed/seed_cbc.c
+crypto/sha/sha.c
+crypto/sha/sha.h
+crypto/sha/sha1.c
+crypto/sha/sha1_one.c
+crypto/sha/sha1s.cpp
+crypto/sha/sha1test.c
+crypto/sha/sha256t.c
+crypto/sha/sha512t.c
+crypto/sha/sha_one.c
+crypto/sha/shatest.c
+crypto/threads/mttest.c
+crypto/threads/th-lock.c
+crypto/ui/ui_openssl.c
+crypto/ui/ui_util.c
+crypto/x509/x509.h
+crypto/x509/x509_txt.c
+crypto/x509v3/v3_addr.c
+engines/e_4758cca.c
+engines/e_capi.c
+engines/e_chil.c
+engines/e_cswift.c
+engines/vendor_defns/hw_ubsec.h
+engines/vendor_defns/hw_ubsec.h
+fips/aes/fips_aes_selftest.c
+fips/aes/fips_aesavs.c
+fips/des/fips_des_selftest.c
+fips/des/fips_desmovs.c
+fips/dsa/fips_dsa_gen.c
+fips/dsa/fips_dsa_selftest.c
+fips/dsa/fips_dsa_sign.c
+fips/dsa/fips_dsatest.c
+fips/dsa/fips_dssvs.c
+fips/fips.c
+fips/fips_premain.c
+fips/fips_test_suite.c
+fips/fips_utl.h
+fips/hmac/fips_hmac.c
+fips/hmac/fips_hmac_selftest.c
+fips/hmac/fips_hmactest.c
+fips/rand/fips_rand.c
+fips/rand/fips_rand_selftest.c
+fips/rand/fips_randtest.c
+fips/rand/fips_rngvs.c
+fips/rsa/fips_rsa_sign.c
+fips/sha/fips_sha1_selftest.c
+fips/sha/fips_shatest.c
+fips/sha/fips_standalone_sha1.c
+openssl/ebcdic.h
+openssl/mdc2.h
+openssl/des_old.h
diff -Naur openssl-1.0.0q.orig/module.import openssl-1.0.0q/module.import
--- openssl-1.0.0q.orig/module.import	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/module.import	2017-04-25 16:23:40.902797419 +0200
@@ -0,0 +1,3 @@
+API_UTIL_CHECKED_STRFTIME	haavardm
+
+	A wrapper function that checks that the time is sane
diff -Naur openssl-1.0.0q.orig/module.tweaks openssl-1.0.0q/module.tweaks
--- openssl-1.0.0q.orig/module.tweaks	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/module.tweaks	2017-04-25 16:23:40.903797546 +0200
@@ -0,0 +1,68 @@
+TWEAK_LIBOPEAY_BN_ASM                   markus
+
+        Turn on this tweak to let the product compile
+        crypto/bn/bn_asm.cpp on its own. There are
+        assembler versions available, but since that
+        depends on the target platform and the build
+        environment, the product is on its own.
+
+        Category   : performance
+        Define     : PRODUCT_COMPILES_BN_ASM
+        Depends on : FEATURE_NATIVE_SSL
+		Enabled for : none
+		Disabled for: desktop, tv, minimal, smartphone, mini
+
+TWEAK_LIBOPEAY_PARTIALLY_DISABLE_MD5			yngve
+
+	When enabled this will disable the MD2 andMD5 method for use in certificates.
+	
+	This does not affect MD5 use in SSL/TLS.
+	
+	MD5 is getting steadily weaker, and this will be the second step towards disabling the method completely.
+	
+	A flag on the remote controlled bitmap preference, PrefsCollectionNetwork::CryptoMethodOverride, 
+	can also disable SHA-1 for certificates when this tweak is _disabled_.
+	
+	If TWEAK_LIBOPEAY_DISABLE_MD5_COMPLETELY is enabled this tweak is not needed.
+	
+	This tweak should not be enabled except as directed by the security group. This may be done sometime during or after 2010.
+	
+	Category: setting
+	Define		: LIBOPEAY_DISABLE_MD5_PARTIAL
+	Enabled for	: none
+	Disabled for	: desktop, smartphone, tv, minimal, mini
+
+TWEAK_LIBOPEAY_PARTIALLY_DISABLE_SHA1			yngve
+
+	When enabled this will disable the SHA1 method for use in certificates.
+	
+	This does not affect SHA-1 use in SSL/TLS or PKCS #12.
+	
+	SHA1 is getting steadily weaker, and this will be the second step towards disabling the metho completely.
+	
+	A flag on the remote controlled bitmap preference, PrefsCollectionNetwork::CryptoMethodOverride, 
+	can also disable SHA-1 for certificates when this tweak is _disabled_.
+	
+	If TWEAK_LIBOPEAY_DISABLE_SHA1_COMPLETELY is enabled this tweak is not needed.
+	
+	This tweak should not be enabled except as directed by the security group. This may be done sometime after 2011.
+	
+	Category: setting
+	Define		: LIBOPEAY_DISABLE_SHA1_PARTIAL
+	Enabled for	: none
+	Disabled for	: desktop, smartphone, tv, minimal, mini
+
+TWEAK_LIBOPEAY_USE_SYSTEM_OPENSSL_LIBRARY		yngve
+
+	When enabled almost all libopeay code is disabled, and the functions are expected to be 
+	linked from OpenSSL 0.9.8 libcrypto. This linking must be configured in the product.
+	
+	The files in addon/, plus the evp/c_alld.c and x509/x509_vfy.c files are still included 
+	because they have special modifications needed to maintain security and/or functionality
+	(such as Extended Validation and disabling MD2 support in certificates).
+	These files are indicated in module.sources with the directive "[include-with-system-lib]"
+	
+	Category	: setting
+	Define		: _USE_SYSTEM_LIBCRYPTO_
+	Enabled for : none
+	Disabled for: desktop, smartphone, tv, minimal, mini
diff -Naur openssl-1.0.0q.orig/openssl/aes.h openssl-1.0.0q/openssl/aes.h
--- openssl-1.0.0q.orig/openssl/aes.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/aes.h	2017-04-25 16:23:40.903797546 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/aes/aes.h"
